// import 'package:app_svoy/connection/methods/exceptions.dart';
import 'package:dio/dio.dart';

// import '../value/values.dart';

abstract class BaseMethod<T> {
  // String get receivedUrl;

  String get url => host + endPoint;

  String get endPoint;

  String host = "";
  Map<String, dynamic>? get queryParameters => {};
  Map<String, dynamic>? get header => {};

  String? get authToken => null;

  Future<T?> onSuccess({required dynamic body});

  Function(String error)? onError;

  final int connectTimeout = 15000;
  final int receiveTimeout = 15000;
  final int sendTimeout = 15000;

  result({
    required Response<dynamic> result,
    required Function(dynamic data)? onSuccess,
    // Function(String error)? onError,
  }) async {
    // if (result.statusCode! >= 200 && result.statusCode! < 300) {
    await onSuccess?.call(result.data);
    // }
  }

  Dio common() {
    Map<String, dynamic> header = {
      "Content-Type": "application/json",
    };
    if (this.header != null) {
      header.addAll(this.header!);
    }
    if (authToken != null) {
      header.addAll({"Authorization": "Bearer $authToken"});
    }
    return Dio(
      BaseOptions(
        headers: header,
        connectTimeout: connectTimeout,
        receiveTimeout: receiveTimeout,
        sendTimeout: sendTimeout,
      ),
    );
  }

  String get api => endPoint
      .replaceAll("/api/", "")
      .replaceAll("https://", "")
      .replaceAll("http://", "")
      .replaceAll("/", "-");
}
