import 'package:dio/dio.dart';

class DioExceptions implements Exception {
  DioExceptions.fromDioError(DioError dioError) {
    switch (dioError.type) {
      case DioErrorType.cancel:
        message = "Запрос к серверу API был отменен";
        break;
      case DioErrorType.connectTimeout:
        message = "Время соединения с сервером истекло";
        break;
      case DioErrorType.other:
        message = "connection_error";
        break;
      case DioErrorType.receiveTimeout:
        message = "Время получения в связи с сервером истекло";
        break;
      case DioErrorType.response:
        message =
            handleError(dioError.response?.statusCode, dioError.response?.data);
        break;
      case DioErrorType.sendTimeout:
        message = "Время отправки в связи с сервером истекло";
        break;
      default:
        message = "Что-то пошло не так";
        break;
    }
  }

  late String message;

  String handleError(int? statusCode, dynamic error) {
    switch (statusCode) {
      case 400:
        return 'Неверный запрос';
      case 404:
        return error["message"] ?? error['text'] ?? error;
      case 500:
        return 'Внутренняя ошибка сервера';
      default:
        return 'Упс! Что-то пошло не так';
    }
  }

  @override
  String toString() => message;
}
